=== debian/changelog ===
ktextaddons (1.9.1-3) unstable; urgency=medium

  [ Patrick Franz ]
  * Add missing dependency of qt6-speech-dev to libktextaddons-dev.

 -- Patrick Franz <deltaone@debian.org>  Fri, 20 Feb 2026 21:43:31 +0100

ktextaddons (1.9.1-2) unstable; urgency=medium

  [ Patrick Franz ]
  * Update symbols from buildlogs.

 -- Patrick Franz <deltaone@debian.org>  Fri, 20 Feb 2026 20:33:50 +0100

ktextaddons (1.9.1-1) unstable; urgency=medium

  [ Benxi Yang ]
  * New upstream release.
  * Migrate to debian/watch version 5 syntax.
  * Drop qch files.
  * Rename libautogenerate to libutils.
  * Bump to std-ver 4.7.3, remove priority field.
  * Add missing dependency libkf6iconthemes-dev.
  * Update copyright file.

  [ Patrick Franz ]
  * Update d/copyright.
  * Update lintian-overrides.

 -- Patrick Franz <deltaone@debian.org>  Wed, 18 Feb 2026 21:00:41 +0100
