=== debian/watch ===
Version: 5
Source: https://download.kde.org/stable/@PACKAGE@/
Matching-Pattern: @PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
Pgp-Mode: auto
